%global php_apiver  %((echo 0; php -i 2>/dev/null | sed -n 's/^PHP API => //p') | tail -1)
%global php_extdir  %(php-config --extension-dir 2>/dev/null || echo "undefined")
%global php_version %(php-config --version 2>/dev/null || echo 0)

Summary: Web indexing and search system for a small domain or intranet
Name: mnogosearch
Version: 3.3.11
Release: 1%{?dist}
License: GPLv2+
Group: Applications/Internet
URL: http://www.mnogosearch.org/

Packager: Dag Wieers <dag@wieers.com>
Vendor: Dag Apt Repository, http://dag.wieers.com/apt/

Source0: http://www.mnogosearch.org/Download/mnogosearch-%{version}.tar.gz
Source1: mnogosearch-reindex
Source2: mnogosearch.crond
Source3: httpd.conf
# makes adapting the configuration more easy, taken from upstream cvs
Patch0: mnogosearch-3.3.11-prepare-config.patch
# modify the default configuration suitable for our distribution
# distribution-specific, not upstream
Patch1: mnogosearch-distconfig.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: autoconf
BuildRequires: automake
BuildRequires: catdoc
BuildRequires: docbook-utils
BuildRequires: expat-devel
#BuildRequires: firebird-devel
BuildRequires: freetds-devel
BuildRequires: libtool
BuildRequires: mysql-devel
BuildRequires: ncurses-devel
BuildRequires: openjade
BuildRequires: openssl-devel
BuildRequires: php-cli
BuildRequires: php-devel
BuildRequires: postgresql-devel
BuildRequires: readline-devel
BuildRequires: sqlite-devel
BuildRequires: unixODBC-devel
#BuildRequires: xlhtml
BuildRequires: zlib-devel
# user "apache" is added to mnogosearch group so we need the user to be present
Requires(post): httpd
Requires(pre): shadow-utils
Requires: %{name}-libs = %{version}-%{release}
Requires: /usr/bin/wvHtml
Requires: /usr/bin/pdftohtml
#Requires: /usr/bin/xlhtml
#Requires: /usr/bin/ppthtml
#Requires: /usr/bin/unrtf

%filter_provides_in %{php_extdir}/.*\.so$
%filter_setup

# build is done with unit testing by default, but it can be disabled
# by --without tests to save time
%define with_tests  %{?_without_tests:  0} %{?!_without_tests:  1}

%description
mnoGoSearch (formerly known as UdmSearch) is a full-featured Web search engine
that you can use to build search engines over HTTP, HTTPS, FTP, and NTTP
servers, local files, and database big text fields. It supports Oracle, MS SQL
Server, MySQL, PostgreSQL, InterBase/Firebird, Openlink Virtuoso, Intersystems
Cach, iODBC, EasySoft ODBC, and unixODBC database backends. It has XML, HTML,
and TEXT built-in support, and external converters support for other document
types. An automatic language/charset guesser for more 70 language/charset
combinations is included, along with basic authorization support, and you may
index password-protected intranet HTTP servers with proxy authorization
support.

mnoGoSearch is built with support for mysql (including fulltext extension),
sqlite, postgresql, firebird, unixODBC and freetds.

%package libs
Summary: Libraries for %{name}
Group: System Environment/Libraries

%description libs
This package contains the %{name} library files.

%package devel
Summary: Development headers and libraries for %{name}
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the %{name} development files.

%package php
Summary: PHP-extension for %{name}
Group: Applications/Internet
Requires: %{name}-libs = %{version}-%{release}
Requires: php-api = %{php_apiver}

%description php
This package contains the PHP extension for %{name}

%prep
%setup

%patch0 -p1
%patch1 -p1

%build
autoreconf -fi
%configure \
    --sysconfdir="%{_sysconfdir}/mnogosearch" \
    --datadir="%{_datadir}/mnogosearch" \
    --localstatedir="%{_localstatedir}/lib/mnogosearch" \
    --includedir="%{_includedir}/mnogosearch" \
    --enable-fhs-layout \
    --enable-file \
    --enable-ftp \
    --enable-http \
    --enable-mp3 \
    --enable-news \
    --enable-parser \
    --enable-syslog="LOG_LOCAL6" \
    --with-docs \
    --with-extra-charsets="all" \
    --with-freetds="%{_prefix}" \
    --with-mysql \
    --with-openssl="%{_prefix}" \
    --with-pgsql \
    --with-readline \
    --with-sqlite3 \
    --with-unixODBC \
    --with-zlib
#    --with-ibase \
#    --enable-mysql-fulltext-plugin \

%{__make} %{?_smp_mflags}

%install
%{__rm} -rf %{buildroot}
%{__make} install DESTDIR="%{buildroot}" \
    doc_FILES='$(HTML_ALL)'

# no need to call the config files *-dist
(cd %{buildroot}%{_sysconfdir}/mnogosearch/
for file in *-dist ; do
    mv -f $file $(basename $file -dist)
done
)

# comment out the converters not available on RHEL/EPEL
sed -i 's|^\(.*xlhtml.*\)$|#\1|g' %{buildroot}%{_sysconfdir}/%{name}/indexer.conf
sed -i 's|^\(.*ppthtml.*\)$|#\1|g' %{buildroot}%{_sysconfdir}/%{name}/indexer.conf
sed -i 's|^\(.*unrtf.*\)$|#\1|g' %{buildroot}%{_sysconfdir}/%{name}/indexer.conf

# the cgi is no regular binary, move it to libexec
install -d %{buildroot}%{_libexecdir}/mnogosearch/
mv -f %{buildroot}%{_bindir}/*.cgi %{buildroot}%{_libexecdir}/mnogosearch/

# the .la's confuse libtool when building the php lib and they should not
# be packaged at all, so remove them
%{__rm} -f %{buildroot}%{_libdir}/*.la

%{__install} -m0755 %{SOURCE1} %{buildroot}%{_bindir}/

%{__install} -Dp -m0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/cron.d/mnogosearch
%{__install} -Dp -m0644 %{SOURCE3} %{buildroot}%{_sysconfdir}/httpd/conf.d/mnogosearch.conf

pushd php
/usr/bin/phpize
%configure --with-mnogosearch="%{buildroot}%{_prefix}"

# get rid of rpath
sed -i 's|-Wl,-rpath,[^ ]*||g' Makefile

%{__make} %{?_smp_mflags} EXTRA_LDFLAGS="-L%{buildroot}%{_libdir}" EXTRA_CFLAGS="-I%{buildroot}%{_includedir}/mnogosearch"
%{__make} install INSTALL_ROOT="%{buildroot}"
popd

install -d %{buildroot}%{_sysconfdir}/php.d/
cat >%{buildroot}%{_sysconfdir}/php.d/mnogosearch.ini <<EOF
; Enable mnogosearch extension module
extension=mnogosearch.so
EOF

# end PHP stuff
# ---------------------

# create state-dir
install -d %{buildroot}%{_localstatedir}/lib/mnogosearch

# fix docs
rm -rf html; mkdir -p html
cp -p doc/*.html html/
rm -rf %{buildroot}/usr/doc

%check
# run unit tests with sqlite backend
touch ./msearch-test/sqlite.db
export UDM_TEST_DBADDR="sqlite3://$(pwd)/msearch-test/sqlite.db/,sqlite3://$(pwd)/msearch-test/sqlite2.db/"
%{__make} check

%clean
%{__rm} -rf %{buildroot}

%pre
# create mnogosearch user and group
getent group mnogosearch >/dev/null || groupadd -r mnogosearch
getent passwd mnogosearch >/dev/null || \
    useradd -r -g mnogosearch -d %{_localstatedir}/lib/mnogosearch \
    -c "User the indexer of the mnoGoSearch search engine is executed with" \
    -s /sbin/nologin mnogosearch
exit 0

%post
# the cgi (executed with the apache user) must be able to read the database:
# the apache user must be in the mnogosearch group
usermod -a -G mnogosearch apache || :

# we brought our own apache config snippet and new group rights
service httpd condrestart > /dev/null 2>&1 || :

# create default mnogosearch database (only during install)
if [ $1 -eq 1 ] ; then
    /usr/bin/indexer --create >/dev/null
    chown mnogosearch:mnogosearch %{_localstatedir}/lib/mnogosearch/default.db
    # db must be group writeable to allow query tracking
    chmod 0660 %{_localstatedir}/lib/mnogosearch/default.db
fi

%postun
service httpd condrestart > /dev/null 2>&1 || :

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files
%defattr(-, root, root, 0755)
%{_bindir}/indexer
%{_bindir}/mconv
%{_bindir}/mguesser
%{_bindir}/mnogosearch-reindex
%dir %{_libexecdir}/mnogosearch/
%{_libexecdir}/mnogosearch/search.cgi
%config(noreplace) %{_sysconfdir}/cron.d/mnogosearch
%config(noreplace) %{_sysconfdir}/httpd/conf.d/mnogosearch.conf

%defattr (0644, root, root, 0755)
%doc AUTHORS ChangeLog COPYING FAQ INSTALL NEWS README README.CVS README.XML TODO html/ doc/samples/
%{_mandir}/man?/*
%{_datadir}/mnogosearch

# the config files of mnogosearch often contain database passwords -> should not be world readable
%defattr (0640,root,mnogosearch,0750)
%dir %{_sysconfdir}/mnogosearch

# indexer.conf is executable: has a correct shebang to run the indexer with this configuration
%attr(0755,root,mnogosearch) %config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mnogosearch/indexer.conf
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mnogosearch/langmap.conf
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mnogosearch/stopwords.conf
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mnogosearch/search.htm
%config(noreplace) %verify(not size mtime md5) %{_sysconfdir}/mnogosearch/node.xml

# default dir for search databases should not be world-readable:
# the search engine could have indexed secret files
%attr (0750,mnogosearch,mnogosearch) %dir %{_localstatedir}/lib/mnogosearch

%files libs
%defattr(-, root, root, 0755)
%{_libdir}/lib*-*.so

%files devel
%defattr(-, root, root, 0755)
%{_bindir}/udm-config
%{_includedir}/mnogosearch
%{_libdir}/*.a
%{_libdir}/libmnogosearch.so
%{_libdir}/libmnogocharset.so

%files php
%defattr(-, root, root, 0755)
%{_sysconfdir}/php.d/mnogosearch.ini
%{php_extdir}

%changelog
* Thu Feb 17 2011 Dag Wieers <dag@wieers.com> - 3.3.11-1
- Initial package. (using DAR)
